# Struct que representa los nodos de una lista doblemente enlazada
Nodo = Struct.new(:value, :next, :prev)

# Clase que representa una lista doblemente enlazada
class Lista
    # Se incluye el módulo Enumerable
    include Enumerable
    #Atributos
    attr_reader :inicio, :final

    # Método each para que la clase sea enumerable
    def each
        nodo = @inicio
        while (nodo != nil)
            yield nodo.value
            nodo = nodo.next
        end
    end
    
	# Meodo initialize para la llamada del new
    def initialize()
        @inicio = nil
        @final = nil
    end
    
    # Método que compurba si la lista está vacía
    def empty()
        if (@inicio == nil)
            vacio = true
        else
            vacio = false
        end

        vacio
    end

    # Método que inserta un menú por el inicio
    def insert_inicio (valor)
        aux_nodo = Nodo.new(valor, nil, nil)

        if(empty)
            @final = aux_nodo
            @inicio = aux_nodo
        else
            aux_nodo.next = @inicio
            @inicio.prev = aux_nodo
            @inicio = aux_nodo
        end

        true
    end

    # Método que extrae un menú por el inicio
    def extract_inicio
        if(empty)
            valor = false
        else
            valor = @inicio.value
            if (@inicio.next == nil)
                @inicio = nil
                @final = nil
                else
                    @inicio = @inicio.next
                    @inicio.prev = nil
                end
        end

        valor
    end

    # Método que inserta un menú por el final
    def insert_final (valor)
        aux_nodo = Nodo.new(valor, nil, nil)

        if(empty)
            @final = aux_nodo
            @inicio = aux_nodo
        else
            aux_nodo.prev = @final
            @final.next = aux_nodo
            @final = aux_nodo
        end

        true
    end

    # Método que extrae un menú por el final
    def extract_final
        if(empty)
            valor = false
        else
            valor = @final.value
            if (@final.prev == nil)
                @inicio = nil
                @final = nil
                else
                    @final = @final.prev
                    @final.next = nil
                end
        end

        valor
    end    
end
