# Módulo para representar menús
module Menu
	# Clase que representa menús dietéticos
	class Menu
		# Se incluye el módulo Comparable
		include Comparable
		# Atributos
	    attr_reader :titulo , :porcent, :plat, :vct, :prot, :grss, :hidr

		# Método para la comparación de menús con el módulo comparable
	    def <=>(other)
	    	vct <=> other.vct
	    end
	    
	    # Meodo initialize para la llamada del new
	    def initialize (titulo, porcent, plat, vct, prot, grss, hidr)
	        @titulo = titulo
	        @porcent = porcent
	        @plat = plat
    		@vct = vct
	        @prot = prot
	        @grss = grss
	        @hidr = hidr	        
	    end
	
		# Método que devuelve el título del menú
	    def get_titulo
	        @titulo
	    end

		# Método que devuelve el porcentaje diario de un menú
	    def get_porcentaje
	       @porcent
	    end

		# Método que devuelve la descripción como string
	    def get_desc(n)
	    	s = "#{@plat[n-1][0]}"
	    end

		# Método que devuelve la porción como string
	    def get_prcn(n)
	    	s = "#{@plat[n-1][1]}"
	    end

		# Método que devuelve la ingesta como string
	    def get_ing(n)
	    	s = "#{@plat[n-1][2]}"
	    end

		# Método que devuelve un plato como string
	    def get_un_plat(n)
			s = "#{get_desc(n)}, "
			s << "#{get_prcn(n)}, "
			s << "#{get_ing(n)}"
			s
		end

		# Método que devuelve el conjunto de platos como string
		def get_conjunto_plat
			i = 1
			s = ""
			while i <= @plat.length
				s << "- #{get_un_plat(i)}"
				i += 1
				if i <= @plat.length
					s << "\n"
				end
			end
			s
		end

		# Método que devuelve el VCT como string
	    def get_vct
	       @vct 
	    end
	    
	    # Método que devuelve el porcentaje de proteínas como string
	    def get_prot
	       @prot
	    end
	    
	    # Método que devuelve el porcentaje de grasas como string
	    def get_grss
	       @grss 
	    end
	    
	    # Método que devuelve el porcentaje de carbohidratos como string
	    def get_hidr
	       @hidr 
	    end
		
		# Método que devuelve el menú como string
	    def to_s
			s = "\n#{get_titulo} (#{get_porcentaje})\n#{get_conjunto_plat}"
			s << "\nVCT: #{get_vct} kcal | "
			s << "#{get_prot}% proteínas - "
			s << "#{get_grss}% grasas - "
			s << "#{get_hidr}% hidratos de carbono\n"
			s
		end
	end
end