class Menu_DSL
	attr_accessor :dia, :titu, :porc, :plat, :vct, :prot, :gras, :hidr

	def initialize(dia, &block)
		self.dia = dia
		self.titu = ""
		self.porc = []
		self.plat = []
		self.vct = nil
		self.prot = nil
		self.gras = nil
		self.hidr = nil

		if block_given?
			if block.arity == 1
				yield self
			else
				instance_eval(&block)
			end
		end
	end

	def to_s
		output = "\n#{dia}"
		output << "\n#{'=' * dia.size}\n\n"
		output << "#{titu} | (#{porc.join(' - ')})%\n"
		plat.each_with_index do |platos|
			output << "- "
			platos.each_with_index do |plato, index|
				output << "#{plato}"
				if index+1 != platos.size
					output << ", "
				end
			end
			output << "\n"
		end
		output << "V.C.T | %\t#{vct} kcal | "
		output << "#{prot}% - #{gras}% - #{hidr}%"

		output
	end

	def titulo (titul)
		titu << titul
	end

	def ingesta (options = {})
		porcentaje = []
		porcentaje << options[:min] if options[:min]
		porcentaje << options[:max] if options[:max]

		porc << porcentaje
	end

	def plato (options = {})
		platos = []
		platos << options[:descripcion] if options[:descripcion]
		platos << options[:porcion] if options[:porcion]
		platos << options[:gramos] if options[:gramos]

		plat << platos
	end

	def porcentajes (options = {})
		@vct = options[:kcals] if options[:kcals]
		@prot = options[:proteinas] if options[:proteinas]
		@gras = options[:grasas] if options[:grasas]
		@hidr = options[:hidratos] if options[:hidratos]
	end
end
